@use "../../icons.scss";

.messageOverlay {
  visibility: hidden;
  &[visible=true] {
    visibility: visible;
  }

  // create background
  &::before {
    position: absolute;
    background-color: var(--background-color);
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;

    opacity: 50%;
    content: "";
  }
  display: flex;
  justify-content: center;
  align-items: center;

  // actual message
  & > .container {
    position: relative;
    box-sizing: border-box;
    max-width: 100%;
    max-height: 100%;
    z-index: 10;
    background-color: var(--background-color);
    box-shadow: 0 0.1em 0.5em var(--shadow-color);

    padding: 1em;
    display: grid;
    grid-template-areas: 
      "icon title close"
      "message message message"
      "buttons buttons buttons"
    ;
    grid-template-columns: max-content 1fr max-content;
    grid-template-rows: max-content 1fr max-content;

    & > .icon {
      grid-area: icon;
      width: 3em;
      height: 3em;
      margin-right: 0.6em;
    }
    &.error > .icon { @include icons.error; }
    &.warning > .icon { @include icons.warning; }
    &.loading > .icon { @include icons.loading; }
    &:not(.error):not(.warning):not(.loading) > .icon {
      @include icons.info;
    }

    & > .title {
      grid-area: title;
      font-size: 170%;
      align-self: center;
      margin-right: 3em;
    }

    & > .close {
      grid-area: close;
      margin-left: 1em;
      width: 1.5em;
      height: 1.5em;
      @include icons.close;
    }

    & > .message {
      grid-area: message;
      margin: 0.6em 1em 0;
      font-size: 130%;
    }
    & > .buttonHolder {
      margin-top: 1em;
      grid-area: buttons;
      display: flex;
      justify-content: space-around;

      & > .button {
        padding: 0 1em;
      }
    }
  }
}
